﻿//Created by Action Script Viewer - http://www.buraks.com/asv
package com.media {
    import flash.events.*;
    import flash.media.*;
    import flash.net.*;

    public class SoundDispatcher extends EventDispatcher {

        private var sound:Sound;
        private var soundChannel:SoundChannel;
        private var transform:SoundTransform;
        private var startTime:Number = 0;
        private var _playing:Boolean;
        private var _paused:Boolean;
        private var _scrubbing:Boolean;

        public function SoundDispatcher(){
            this.soundChannel = new SoundChannel();
            this.transform = new SoundTransform();
            super();
        }
        public function play(_arg1:String):void{
            this.sound = new Sound();
            this.sound.load(new URLRequest(_arg1));
            this.configureListeners(this.sound, true);
            this.soundChannel = this.sound.play();
            this.soundChannel.soundTransform = this.transform;
            this.soundChannel.addEventListener(Event.SOUND_COMPLETE, this.soundCompleteHandler);
            this._playing = true;
            this._paused = false;
            this._scrubbing = false;
        }
        private function configureListeners(_arg1:EventDispatcher, _arg2:Boolean):void{
            if (_arg2){
                _arg1.addEventListener(Event.ID3, this.id3Handler);
                _arg1.addEventListener(ProgressEvent.PROGRESS, this.progressHandler);
                _arg1.addEventListener(Event.COMPLETE, this.completeHandler);
                _arg1.addEventListener(IOErrorEvent.IO_ERROR, this.ioErrorHandler);
                _arg1.addEventListener(SecurityErrorEvent.SECURITY_ERROR, this.securityErrorHandler);
            } else {
                _arg1.removeEventListener(Event.ID3, this.id3Handler);
                _arg1.removeEventListener(ProgressEvent.PROGRESS, this.progressHandler);
                _arg1.removeEventListener(Event.COMPLETE, this.completeHandler);
                _arg1.removeEventListener(IOErrorEvent.IO_ERROR, this.ioErrorHandler);
                _arg1.removeEventListener(SecurityErrorEvent.SECURITY_ERROR, this.securityErrorHandler);
            };
        }
        private function id3Handler(_arg1:Event):void{
            dispatchEvent(new Event(Event.ID3));
        }
        private function progressHandler(_arg1:ProgressEvent):void{
            dispatchEvent(new Event(ProgressEvent.PROGRESS));
        }
        private function ioErrorHandler(_arg1:IOErrorEvent):void{
            dispatchEvent(new Event(IOErrorEvent.IO_ERROR));
        }
        private function completeHandler(_arg1:Event):void{
            if (this.sound.length == 0){
                dispatchEvent(new Event(IOErrorEvent.IO_ERROR));
            };
            dispatchEvent(new Event(Event.COMPLETE));
        }
        private function securityErrorHandler(_arg1:SecurityErrorEvent):void{
            dispatchEvent(new Event(SecurityErrorEvent.SECURITY_ERROR));
        }
        private function soundCompleteHandler(_arg1:Event):void{
            if (!this._scrubbing){
                this.next();
                dispatchEvent(new Event(Event.SOUND_COMPLETE));
            };
        }
        public function close():void{
            if (this.sound != null){
                this.soundChannel.stop();
                try {
                    this.sound.close();
                } catch(error:Error) {
                };
                this.configureListeners(this.sound, false);
                this.soundChannel.removeEventListener(Event.SOUND_COMPLETE, this.soundCompleteHandler);
                this.sound = null;
            };
        }
        public function next():void{
        }
        public function stop():void{
            this.startTime = 0;
            this.seek(this.startTime);
            this.soundChannel.stop();
            this._playing = false;
        }
        public function pause():void{
            this.startTime = this.soundChannel.position;
            this.soundChannel.stop();
            this._paused = true;
        }
        public function resume():void{
            this._playing = true;
            this._paused = false;
            this.soundChannel.stop();
            this.seek(this.startTime);
        }
        public function seek(_arg1:Number):void{
            if (!this._paused){
                this.soundChannel.stop();
                this.soundChannel = this.sound.play(_arg1);
                this.soundChannel.soundTransform = this.transform;
                this.soundChannel.addEventListener(Event.SOUND_COMPLETE, this.soundCompleteHandler);
                if ((((_arg1 > 0)) && ((_arg1 >= this.duration)))){
                    this.next();
                    dispatchEvent(new Event(Event.SOUND_COMPLETE));
                };
            } else {
                this.soundChannel = this.sound.play(_arg1);
                this.startTime = this.soundChannel.position;
                this.soundChannel.stop();
            };
        }
        public function get volume():Number{
            return (this.transform.volume);
        }
        public function set volume(_arg1:Number):void{
            this.transform.volume = _arg1;
            if (this.soundChannel != null){
                this.soundChannel.soundTransform = this.transform;
            };
        }
        public function get bytesLoaded():Number{
            return (this.sound.bytesLoaded);
        }
        public function get bytesTotal():Number{
            return (this.sound.bytesTotal);
        }
        public function get position():Number{
            return (this.soundChannel.position);
        }
        public function get length():Number{
            return (this.sound.length);
        }
        public function get duration():Number{
            return ((this.sound.length / (this.sound.bytesLoaded / this.sound.bytesTotal)));
        }
        public function get ID3Info():Object{
            return (this.sound.id3);
        }
        public function get playing():Boolean{
            return (this._playing);
        }
        public function get paused():Boolean{
            return (this._paused);
        }
        public function set scrubbing(_arg1:Boolean):void{
            this._scrubbing = _arg1;
        }

    }
}//package com.media 
